<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.11.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>VICOLib: README</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
  $(function() { init_search(); });
/* @license-end */
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="Logo.png"/></td>
  <td id="projectalign">
   <div id="projectname">VICOLib
   </div>
   <div id="projectbrief">Software documentation</div>
  </td>
    <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <span id="MSearchSelect"                onmouseover="return searchBox.OnSearchSelectShow()"                onmouseout="return searchBox.OnSearchSelectHide()">&#160;</span>
          <input type="text" id="MSearchField" value="" placeholder="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.svg" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.11.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('index.html',''); initResizable(true); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div><div class="header">
  <div class="headertitle"><div class="title">README </div></div>
</div><!--header-->
<div class="contents">
<div class="toc"><h3>Table of Contents</h3>
<ul><li class="level1"><a href="#Introduction">Introduction</a></li>
<li class="level1"><a href="#sec">Quick Start</a><ul><li class="level2"><a href="#opsys">Operating Systems</a></li>
<li class="level2"><a href="#sampleprojects">Example Projects</a></li>
<li class="level2"><a href="#API">API Stucture</a></li>
</ul>
</li>
<li class="level1"><a href="#support">Support</a></li>
</ul>
</div>
<div class="textblock"><h1><a class="anchor" id="Introduction"></a>
Introduction</h1>
<p>This documentation for VICOLib describes the API for KETEK devices of the VICO-DV/-AV 3.0 family. VICOLib is designed to provide easy control of your KETEK device in custom scripts implementations.<br  />
</p><ul>
<li>Find the library API documentation within <a class="el" href="a00002.html">vicolib.h</a> <br  />
</li>
<li>Find the types documentation within <a class="el" href="a00008.html">types.h</a> <br  />
</li>
<li>Find the constants within <a class="el" href="a00005.html">constants.h</a> <br  />
</li>
</ul>
<p>VICOLib is compatible with both analog &ndash; which are not equipped with a digital pulse processor (e.g., VICO-AV) &ndash; and digital systems &ndash; which are equipped with an internal digital pulse processor (e.g., VICO-DV). However, some API functions can only be used with digital systems since they relate to the digital pulse processor (e.g., setting a peaking time). These functions can be identified by their return type, which is <a class="el" href="a00008.html#a5e0b8308439c337e74cbedce93d9c53a" title="DPP-related return codes.">DPPStatusType</a>. Applying a function with the return type <a class="el" href="a00008.html#a5e0b8308439c337e74cbedce93d9c53a" title="DPP-related return codes.">DPPStatusType</a> to an analog system has no effect on the device and will lead to a <a class="el" href="a00008.html#a5e0b8308439c337e74cbedce93d9c53aacd1720966224e491f9c16d46fee8fa6c" title="0x57: VICOLib return code: Command is not applicable for the targeted device (e.g.">DPP_COMMAND_NOT_SUPPORTED_ERROR</a>. On the other hand, API functions using the return types <a class="el" href="a00008.html#ade5e6c98769a15a4611a6ff810ea66c8" title="MCU-related return codes.">MCUStatusType</a> or <a class="el" href="a00008.html#a42c6cba0402a9b6d29b4b9a3d1af2de1" title="VICOLib-related return codes.">VICOStatusType</a> can be applied to both, analog and digital systems.</p>
<h1><a class="anchor" id="sec"></a>
Quick Start</h1>
<p>In order to quickly built your first script controlling a VICO device we recommend the following steps:</p><ol type="1">
<li>Acquire a VICOLib distribution suitable for your operating system (see <a class="el" href="#opsys">Operating Systems</a>).</li>
<li>Import the VICOLib into your scripting environment (see <a class="el" href="#sampleprojects">Example Projects</a> for examples).</li>
<li>Make sure that the VICODaemon process is running on your system (see <a class="el" href="#API">API Stucture</a>).</li>
<li>Find VICO devices connected to your system using the scanning functions of VICOLib (<a class="el" href="a00002.html#a8d152368a62de4e41f2898784ad7e0c0" title="Scans for USB-connected devices and builds up a lasting connection to all found USB devices in the VI...">scanUsbDevices()</a>, <a class="el" href="a00002.html#a9a6710f8884c9ca3d4945f4f07912397" title="Scans for TCP-connected ethernet devices between the range of given IP addresses.">scanTcpDevices()</a>, and <a class="el" href="a00002.html#a557df57cbf3069a52c6ff98ea1ffbb40" title="Scans for UDP-connected ethernet devices by performing a directed broadcast in VICODaemon.">scanUdpDevices()</a>). Use <a class="el" href="a00002.html#a417b5b3edfeeacf0a2480c76c88a4aed" title="Reads the number of devices currently maintained by the VICODaemon.">getNumberOfDevices()</a> and <a class="el" href="a00002.html#a61581639667abd6578b9e1cd363de3de" title="Reads the device information of a device connected within VICODaemon.">getDeviceInfoByIndex()</a> to check which VICO devices were found and connected to VICODaemon during the scans.</li>
<li>Use the VICOLib functions described in <a class="el" href="a00002.html">vicolib.h</a> in order to configure and control the VICODevice in a way suitable for your application. The evaluation of the return code of every function call is strongly recommended in order to ensure the proper execution of commands. </li>
</ol>
<h2><a class="anchor" id="opsys"></a>
Operating Systems</h2>
<p>Compiled VICOLib libraries for 64bit version of Windows and Linux are provided. KETEK can also provide the VICOLib source code. Please contact our <a class="el" href="#support">Support</a> to get more information. </p>
<h2><a class="anchor" id="sampleprojects"></a>
Example Projects</h2>
<p>A software development kit (SDK) is available for Windows. You’ll find programming examples in the "Examples" folder in the VICOLib directory. Example projects were created to demonstrate the use of VICOLib in different environments. The respective sample project contains code that uses the VICOLib for a simple measurement process (establish connection to a VICO device, configure device, start measurement, read MCA data and run statistics) or shows the update process of the MCU. Examples have been created for the following programming languages:</p><ul>
<li>Python (IDE Spyder)</li>
<li>Java (IDE Eclipse)</li>
<li>C++ (IDE CodeBlocks)</li>
<li>LabVIEW</li>
</ul>
<p>Please contact our <a class="el" href="#support">Support</a> if you require further coding examples.</p>
<h2><a class="anchor" id="API"></a>
API Stucture</h2>
<p>The API is built out of two components:</p><ul>
<li><b>VICODaeamon</b> is the active backend that handles the communication with the VICO device. VICODaemon is a background process that maintains connections to VICO devices and takes care of all data exchanges between your host system and the VICO device.<br  />
</li>
<li><b>VICOLib</b> is the passive library that allows the user to control the VICO device. The library contains high-level functions that can be called by the user's custom script. These high-level functions are associated with low-level datagrams within the library.</li>
</ul>
<p>When calling a VICOLib function the library will build the corresponding low-level request for the VICO device and delivers it to the VICODaemon. VICODaemon transfers this low-level data to the VICO device, receives the device answer and returns low-level data back to VICOLib. VICOLib processes the low-level device answer and returns an interpretation (e.g., <a class="el" href="a00008.html#a5e0b8308439c337e74cbedce93d9c53aab6e84e71c47ba7e5e2054e889bc8f95a" title="0x00: DPP return code: Request successfully processed.">DPP_SUCCESS</a>) to the user. Therefore, make sure the VICODaeamon process is running on your system whenever you are calling VICOLib functions to control a VICO device. Otherwise VICOLib will return an error (e.g., <a class="el" href="a00008.html#a5e0b8308439c337e74cbedce93d9c53aa22d92c7b43738f4387f9b9f6e1c0747b" title="0x51: VICOLib return code: VICODaemon is currently not running.">DPP_VICODAEMON_IS_STOPPED</a>), since the library is not able to exchange data with the device. Please note: only sequential API calls can be processed by the VICODaemon.</p>
<h1><a class="anchor" id="support"></a>
Support</h1>
<p>If you have questions, feedback or encounter any problems regarding the VICOLib API or the VICO device itself please do not hesitate to contact us via e-mail or phone:</p>
<p>KETEK GmbH <br  />
 Hofer Str. 3 <br  />
 81737 Munich <br  />
 Germany</p>
<p>Phone: +49 (0) 89 673467 70 <br  />
 E-Mail: <a href="#" onclick="location.href='mai'+'lto:'+'inf'+'o@'+'ket'+'ek'+'.ne'+'t'; return false;">info@<span class="obfuscator">.nosp@m.</span>kete<span class="obfuscator">.nosp@m.</span>k.net</a> <br  />
 Homepage: <a href="https://www.ketek.net">www.ketek.net</a> </p>
</div></div><!-- PageDoc -->
<a href="doxygen_crawl.html"/>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.11.0 </li>
  </ul>
</div>
</body>
</html>
